var placeholderText = ''
UE.Editor.prototype.placeholder = function (justPlainText) {
  var _editor = this
  placeholderText = justPlainText
  // _editor.addListener('focus', function () {
  //   var localHtml = _editor.getPlainTxt()
  //   if ($.trim(localHtml) === $.trim(justPlainText)) {
  //     _editor.setContent('')
  //     _editor.focus()
  //   }
  // })
  _editor.addListener('blur', function () {
    var localHtml = _editor.getContent()
    if (!localHtml) {
      _editor.setContent('<p id="initContent">' + justPlainText + '</p>')
    }
  })
  _editor.ready(function () {
    ue._setDefaultContent(justPlainText)
    setTimeout(function () {
      _editor.undoManger.reset()
    }, 10)
  })
}

// 配置项
var maxWord = 30000
var html = ''

var ue = UE.getEditor('editor', {
  // toolbars: [],
  elementPathEnabled: false,
  // serverUrl: '',
  enableContextMenu: false,
  wordCount: false,
  autoFloatEnabled: false,
  allowDivTransToP: false,
  maximumWords: maxWord,
  initialFrameWidth: '100%',
  autoHeightEnabled: false,
  imageScaleEnabled: false,
  imagePopup: false,
  maxUndoCount: 11,
  autotypeset: {
    mergeEmptyline: true, //合并空行
    removeClass: true, //清除格式
    removeEmptyline: false, //去掉空行
    textAlign: 'left', //段落的排版方式，可以是 left,right,center,justify 去掉这个属性表示不执行排版
    imageBlockLine: 'center', //图片的浮动方式，独占一行剧中,左右浮动，默认: center,left,right,none 去掉这个属性表示不执行排版
    pasteFilter: true, //粘贴过滤
    clearFontSize: true, //去掉所有的内嵌字号，使用编辑器默认的字号
    clearFontFamily: true, //去掉所有的内嵌字体，使用编辑器默认的字体
    removeEmptyNode: true, // 清楚冗余html代码
    indent: false, // 行首缩进
    indentValue: '2em', //行首缩进的大小
    bdc2sb: false,
    tobdc: false
  }
  // retainOnlyLabelPasted: true //粘贴只保留标签，去除标签所有属性
})
console.log('container:', ue)

function setWords() {
  // var count =
  //   ue.body.innerHTML === '<p id="initContent">' + placeholderText + '</p>'
  //     ? 0
  //     : ue.getContentLength(true)

  // if (count == 1 && ue.getContentTxt() === '') {
  //   count = 0
  // }
  var count = (ue.getContentTxt() && ue.getContentTxt().length) || 0
  console.log('count', count)

  if (count > maxWord) {
    ue.setContent(html)
    ue.focus(true)
  } else {
    html = ue.body.innerHTML
  }

  count = count > maxWord ? maxWord : count

  $('.input-word')
    .css('color', count > 0 ? '#222222' : '#999999')
    .text(count)

  var ua = window.navigator.userAgent
  var param = {
    inputedLenght: count
  }
  if (ua.indexOf('Android') > -1 || ua.indexOf('Linux') > -1) {
    // Android
    AndroidInterface.didInputed(JSON.stringify(param))
  } else if (!!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
    // ios
    window.webkit.messageHandlers.didInputed.postMessage(param)
  }
}

ue.ready(function () {
  $('.max-word').text(maxWord)
  $('.word-count').show()
  // 解决手机上只输入一次无法回退
  if (ue.undoManger.list.length == 0) {
    ue.undoManger.save(true)
  }

  var startX, startY, moveEndX, moveEndY, X, Y

  getDom('body.view').on({
    click: function (event) {
      var targetElement = event.target || event.srcElement
      // $(this)
      //   .find('.edit_img_input')
      //   .each(function () {
      //     $(this).addClass('not-select')
      //   })

      if (targetElement.parentNode.getAttribute('contenteditable') === 'false') {
        getDom('body.view').blur()
      }

      if (targetElement.classList.contains('close-icon')) {
        console.log('点击了：', targetElement)
        // $(targetElement).parent().remove()
        // $(targetElement).parent().siblings().addBack().remove()
        $(targetElement).parent().next('.edit_img_input').remove()
        $(targetElement).parent().remove()
        ue.undoManger.save()
        setWords()
      } else if (targetElement.classList.contains('edit_img_input')) {
        // $(targetElement).removeClass('not-select')

        if (targetElement.innerText === '点击输入注释') {
          targetElement.innerText = ''
        }
        // if ($(targetElement).attr('contenteditable') === 'false') {
        //   $(targetElement).attr('contenteditable', true)
        // }
      } else if (
        targetElement.classList.contains('play-icon') ||
        targetElement.parentNode.classList.contains('play-icon')
      ) {
        console.log('播放地址', $(targetElement).prev().attr('src'))

        var ua = window.navigator.userAgent
        var param = {
          url: $(targetElement).prev().attr('src')
        }
        if (ua.indexOf('Android') > -1 || ua.indexOf('Linux') > -1) {
          // Android
          AndroidInterface.playVideo(JSON.stringify(param))
        } else if (!!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
          // ios
          window.webkit.messageHandlers.playVideo.postMessage(param)
        }
      }
    },
    input: function (event) {
      if (event.inputType === 'insertFromComposition') {
        ue.undoManger.save()
      }
      setWords()
    },
    touchstart: function (e) {
      e.preventDefault()
      startX = e.touches[0].pageX
      startY = e.touches[0].pageY
    },
    touchmove: function (e) {
      e.preventDefault()
      moveEndX = e.changedTouches[0].pageX
      moveEndY = e.changedTouches[0].pageY
      X = moveEndX - startX
      Y = moveEndY - startY
      if (Math.abs(Y) > 50) {
        var ua = window.navigator.userAgent
        if (ua.indexOf('Android') > -1 || ua.indexOf('Linux') > -1) {
          // Android
          AndroidInterface.touchMove(JSON.stringify(true))
        } else if (!!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
          // ios
          window.webkit.messageHandlers.touchMove.postMessage(true)
        }
      }
    },
    keyup: function (e) {
      console.log(e.keyCode || e.which)
      var keyCode = e.keyCode || e.which
      if (keyCode == 8) {
        var text = getDom('body.view').children(':last-child').text()
        if (text !== '') {
          getDom('body.view').append('<p><br></p><p><br></p>')
        }
      }
      // var range = ue.selection.getRange()
      // var startContainer = range.startContainer
      // var block = startContainer.nodeType === 1 ? startContainer : startContainer.parentNode
      // while (block && !UE.dom.domUtils.isBlockElm(block)) {
      //   block = block.parentNode
      // }
      // if (block) {
      //   if (block.classList.contains('edit_img_input')) {
      //     if (!block.parentNode.nextSibling && !block.parentNode.nextElementSibling) {
      //       let p = document.createElement('p')
      //       let br = document.createElement('br')
      //       p.appendChild(br)
      //       block.parentNode.parentNode.appendChild(p)
      //     }
      //   }
      // }
    }
    // selectstart: function (e) {
    //   e.preventDefault()
    //   return false
    // },
    // dblclick: function (e) {
    //   e.preventDefault()
    //   return false
    // }
  })
})
ue.addListener('click', function () {})
ue.addListener('selectionchange', function () {
  var ua = window.navigator.userAgent
  var params = {
    fontBold: ue.queryCommandState('bold'),
    fontItalic: ue.queryCommandState('italic'),
    fontUnderline: ue.queryCommandState('underline') ? 1 : 0,
    alignment: ue.queryCommandValue('justify'),
    listStyle:
      ue.queryCommandState('insertorderedlist') == 1
        ? 'ordered'
        : ue.queryCommandState('insertunorderedlist')
        ? 'unorder'
        : 'nolist'
  }
  try {
    if (ua.indexOf('Android') > -1 || ua.indexOf('Linux') > -1) {
      // Android
      AndroidInterface.updateSettings(JSON.stringify(params))
    } else if (!!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
      // ios
      window.webkit.messageHandlers.updateSettings.postMessage(params)
    }
  } catch (error) {}
})

function handleResize() {
  var ua = window.navigator.userAgent
  if (!!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
    var height = $('#editor').height()
    if (height) {
      ue.setHeight(height)
    }
    setTimeout(function () {
      var range = ue.selection.getRange()
      var startContainer = range.startContainer
      var block = startContainer.nodeType === 1 ? startContainer : startContainer.parentElement
      // const doc = document.getElementsByTagName('iframe')[0].contentWindow.document
      if (block && block.offsetTop > height) {
        // $('#ueditor_0')
        //   .contents()
        //   .scrollTop(block.offsetTop - height + 66)
        var doc = document.getElementsByTagName('iframe')[0].contentWindow.document
        doc.documentElement.scrollTop = block.offsetTop - height + 88
      }
    }, 200)
  }
}
ue.addListener('focus', function () {
  // ios特殊处理
  handleResize()
})
ue.addListener('blur', function () {
  handleResize()
})
// 粘贴事件
ue.addListener('afterPaste', function () {
  // console.log('粘贴')
})
// 监听删除事件
ue.addListener('delkeydown', function (e) {})

// 设置正文placeholder
window.setPlaceHolder = function (text) {
  console.log('setPlaceHolder', text)
  ue.placeholder(text)
}
// 获得编辑模式焦点
window.setFocus = function () {
  console.log('focus:', ue)
  // ue.focus()
  var range = document.createRange()
  range.selectNodeContents(ue.body)
  range.collapse(false)
  var selection = window.getSelection()
  selection.removeAllRanges()
  selection.addRange(range)
  ue.body.focus()
}
// 第一次执行 文本内容加粗 第二次执行 文本内容取消加粗
window.setEditorBold = function () {
  console.log('setEditorBold:', ue)
  ue.execCommand('bold')
}
// 第一次执行 文本内容斜体 第二次执行 文本内容取消斜体
window.setEditorItalic = function () {
  console.log('setEditorItalic:', ue)
  ue.execCommand('italic')
}
// 第一次执行 字体下划线 第二次执行 字体取消下划线  与删除线互斥
window.setEditorUnderLine = function () {
  console.log('setEditorUnderLine:', ue)
  ue.execCommand('underline')
}
// 第一次执行 字体删除线 第二次执行 字体取消删除线 与下划线互斥
window.setEditorStrikeThrough = function () {
  console.log('setEditorStrikeThrough:', ue)
  ue.execCommand('strikethrough')
}
// value 字体大小
window.setEditorFontSize = function (val) {
  console.log('setEditorFontSize:', val)
  ue.execCommand('fontsize', val)
}
// value 色值(十六进制)
window.setEditorForeColor = function (val) {
  console.log('setEditorForeColor:', val)
  ue.execCommand('forecolor', val)
}
// 段落左对齐
window.setEditorJustifyLeft = function () {
  console.log('setEditorJustifyLeft:', ue)
  ue.execCommand('justify', 'left')
}
// 段落剧中对齐
window.setEditorJustifyCenter = function () {
  console.log('setEditorJustifyCenter:', ue)
  ue.execCommand('justify', 'center')
}
// 段落右对齐
window.setEditorJustifyRight = function () {
  console.log('setEditorJustifyRight:', ue)
  ue.execCommand('justify', 'right')
}
// 段落分部对齐
window.setEditorJustifyJustify = function () {
  console.log('setEditorJustifyJustify:', ue)
  ue.execCommand('justify', 'justify')
}
// 第一次执行 有序列表 第二次执行 有序列表取消 与“insertunorderedlist”命令互斥
window.setEditorInsertOrderedList = function () {
  console.log('setEditorInsertOrderedList:', ue)
  ue.execCommand('insertorderedlist', 'decimal')
}
// 第一次执行 无序列表 第二次执行 无序列表取消 与“insertunorderedlist”命令互斥
window.setEditorInsertUnorderedList = function () {
  console.log('setEditorInsertUnorderedList:', ue)
  ue.execCommand('insertunorderedlist', 'disc')
}
// 分割线
window.setEditorLine = function () {
  console.log('setEditorLine:', ue)
  ue.execCommand(
    'inserthtml',
    `<p id="border" style="width: 100%;margin: 10px 0;position: relative;;border-top: dashed #B71D26 1px;"></p>`
  )
}
// 设置html正文内容
window.setEditorContent = function (html) {
  console.log('setContent:', html)
  let str = ''
  if (html) {
    str = html.replace(/[\u200B-\u200D\uFEFF]/g, '')
  }
  $('.hidden-dom').html(str)

  // 图片
  var imgDoms = document.querySelectorAll('.hidden-dom img')
  for (var i = 0; i < imgDoms.length; i++) {
    var img = imgDoms[i]
    if (img.className.indexOf('remove') > -1) {
      continue
    }
    img.parentNode.style.cssText =
      'text-align:center; position: relative; overflow:hidden;margin-top:10px'
    img.parentNode.setAttribute('contenteditable', false)

    if (img.parentNode.querySelectorAll('.remove').length > 0) {
      continue
    }

    var closeDom = document.createElement('img')
    closeDom.style = 'position: absolute; top: 6px; right: 6px; width: 20px; height: 20px;'
    closeDom.src = './image/close.webp'
    closeDom.setAttribute('class', 'close-icon remove')
    img.parentNode.appendChild(closeDom)
  }

  // 视频
  var videoDoms = document.querySelectorAll('.hidden-dom video')
  for (var i = 0; i < videoDoms.length; i++) {
    var video = videoDoms[i]
    video.controls = false
    video.parentNode.style.cssText = 'position:relative;margin-top:10px'
    video.parentNode.setAttribute('contenteditable', false)

    if (video.parentNode.querySelectorAll('.remove').length > 0) {
      continue
    }

    var playDom = document.createElement('span')
    playDom.setAttribute('class', 'play-icon remove')
    playDom.innerHTML = `<img class="remove" style="width:16px;height:16px;" src="./image/play.png" alt="" />`
    video.parentNode.appendChild(playDom)

    var timeDom = document.createElement('span')
    timeDom.style =
      'position: absolute; bottom: 8px; right: 8px;user-select: none;color: #ffffff; font-size: 12px; font-family:PingFang SC;'
    timeDom.innerHTML = '00:00'
    video.parentNode.appendChild(timeDom)

    var closeDom = document.createElement('img')
    closeDom.style = 'position: absolute; top: 6px; right: 6px; width: 20px; height: 20px'
    closeDom.src = './image/close.webp'
    closeDom.setAttribute('class', 'close-icon remove')
    video.parentNode.appendChild(closeDom)
  }

  ue.setContent($('.hidden-dom').html())
  setWords()
  $('.word-count').show()
  $('.hidden-dom').html('')
}
// 在光标后追加内容
window.addEditorContent = function (html) {
  console.log('addEditorContent:', html)
  ue.execCommand('inserthtml', html)
}
// 获取html全部内容数据(存草稿)
window.getEditorContentSave = function () {
  console.log('getContent:', ue.body.innerHTML)
  $('.hidden-dom').html(ue.body.innerHTML)
  $('.hidden-dom').find('.editor-placeholder').remove()
  let html = $('.hidden-dom').html()
  $('.hidden-dom').html('')
  return html
}
// 获取html全部内容数据(发布)
window.getEditorContent = function () {
  // console.log('getContent:', ue.body.innerHTML)
  $('.hidden-dom').html(ue.body.innerHTML)

  // 移除自定义的dom
  $('.hidden-dom')
    .find('.remove')
    .each(function () {
      $(this).remove()
    })

  $('.hidden-dom')
    .find('.edit_img_input')
    .each(function () {
      if ($(this).text() === '点击输入注释') {
        $(this).remove()
      }
    })

  let html = $('.hidden-dom').html()
  $('.hidden-dom').html('')
  console.log('html', html)
  return html
}
// 获取html纯文本
window.getEditorContentTxt = function () {
  console.log('getContentTxt:', ue.getContentTxt())
  return ue.getContentTxt()
}
// 撤销，恢复 次数
// var undoNum = 0
// var redoNum = 0
// 撤销
window.setEditorUndo = function () {
  console.log('setEditorUndo:', ue.undoManger)
  ue.execCommand('undo')
  // undoNum++
  var obj = {
    nextUndo: ue.undoManger.hasUndo ? 1 : 0,
    nextRedo: ue.undoManger.hasRedo ? 1 : 0
  }
  setWords()
  console.log('setEditorUndo:', ue.undoManger)
  return JSON.stringify(obj)
}
// 取消撤销
window.setEditorRedo = function () {
  console.log('setEditorRedo:', ue)
  ue.execCommand('redo')
  // redoNum++
  var obj = {
    nextRedo: ue.undoManger.hasRedo ? 1 : 0,
    nextUndo: ue.undoManger.hasUndo ? 1 : 0
  }
  setWords()
  console.log('setEditorUndo:', ue.undoManger)
  return JSON.stringify(obj)
}

ue.addListener('contentchange', function (editor) {
  // console.log('1234567', ue.undoManger)
  // undoNum = 0
  // redoNum = 0
  // console.log('AndroidFunction_contentChange')
  // const content = ue.getContent()
  // const contentTxt = ue.getContentTxt()
  // var param = {
  //   content: content,
  //   contentTxt: contentTxt
  // }
  // const userAgent = navigator.userAgent.toLowerCase()
  // if (/android/.test(userAgent) || /adr/.test(userAgent)) {
  //   AndroidFunction?.textChange(JSON.stringify(param))
  // } else if (/iphone|ipad|ipod/.test(userAgent)) {
  //   window.webkitURL.messageHandlers.textChange.postMessage({
  //     content: content,
  //     contentTxt: contentTxt
  //   })
  // } else {
  //   AndroidFunction?.textChange(JSON.stringify(param))
  // }
})

// 插入图片 list: 图片数组列表
window.setEditorImg = function (list) {
  console.log('setEditorImg:', list)
  if (!list) {
    return
  }
  var arr = JSON.parse(list)
  var val = ''
  arr?.forEach((item) => {
    // <p style="height: 0.5px;background: #ededed;margin:9px 0 16px 0;"></p>
    if (item != '') {
      val =
        val +
        `<p style="text-align:center; position: relative; overflow:hidden;margin-top:10px" contenteditable="false"><img 
        src="${item.url}" style="max-width: 100%;border-radius:3px;border: 0.5px solid #0000000d;" /><img 
        style="position: absolute; top: 6px; right: 6px; width: 20px; height: 20px;" 
        class="close-icon remove" src="./image/close.webp" alt=""/></p><p 
        class="edit_img_input" 
        style="padding: 10px 0;color: #b0b0b0;text-align: center;font-size: 12px;font-weight: 400;font-family: PingFang SC;line-height: 14px;min-height:14px;">点击输入注释</p><p><br></p>`
    }
  })
  ue.focus()
  ue.execCommand('inserthtml', val.toString())
  setTimeout(() => {
    setWords()
  }, 10)

  // addEvent()
  // console.log('123', $('#ueditor_0').contents().find('img').attr('src'))
}
// 插入视频
window.setEditorVideo = function (list) {
  console.log('setEditorVideo:', list)
  if (!list) {
    return
  }
  var arr = JSON.parse(list)
  var val = ''
  arr?.forEach((item) => {
    if (item != '') {
      val =
        val +
        `<p style="position:relative;margin-top:10px" contenteditable="false"><video
          width="100%"
          style="background: #000; max-width: 100%;border-radius:3px"
          poster="${item.coverUrl}"
          src="${item.url}"
          playsinline="true"
          x5-playsinline="true"
          webkit-playsinline="true"
        >
          <source src="${item.url}" />
        </video><span class="play-icon remove"><img
        class="remove"
        style="width:16px;height:16px;"
        src="./image/play.png"
        alt=""
      /></span><span class="remove" style="position: absolute; bottom: 8px; right: 8px;user-select: none;color: #ffffff; font-size: 12px; font-family:PingFang SC;">${transTime(
        item.duration || 0
      )}</span><img
        style="position: absolute; top: 6px; right: 6px; width: 20px; height: 20px"
        class="close-icon remove"
        src="./image/close.webp"
        alt=""
    /></p><p class="edit_img_input" style="padding: 10px 0;color: #b0b0b0;text-align: center;font-size: 12px;font-weight: 400;font-family: PingFang SC;line-height: 14px;">点击输入注释</p><p><br></p>`
    }
  })
  ue.focus()
  ue.execCommand('inserthtml', val.toString())
  setTimeout(() => {
    setWords()
  }, 10)
}

// resize https://juejin.cn/post/6844903508446019597
// ios focusin事件
var resizeTimer = null
window.addEventListener(
  'resize',
  function () {
    var height = $('#editor').height()
    if (height) {
      ue.setHeight(height)
    }
    clearTimeout(resizeTimer)
    resizeTimer = setTimeout(function () {
      var range = ue.selection.getRange()
      var startContainer = range.startContainer
      var block = startContainer.nodeType === 1 ? startContainer : startContainer.parentElement
      // const doc = document.getElementsByTagName('iframe')[0].contentWindow.document
      if (block && block.offsetTop > height) {
        // $('#ueditor_0')
        //   .contents()
        //   .scrollTop(block.offsetTop - height + 66)
        var doc = document.getElementsByTagName('iframe')[0].contentWindow.document
        doc.documentElement.scrollTop = block.offsetTop - height + 88
      }
    }, 100)
  },
  false
)

function getDom(dom) {
  return $('#ueditor_0').contents().find(dom)
}

//
$('.word-count').on('click', function () {
  // ue.focus()
})

// function addEvent() {
//   getDom('.close-icon').each(function () {
//     $(this).click(function () {
//       $(this).parent().remove()
//       // ue.fireEvent('contentchange')
//       ue.undoManger && ue.undoManger.save()
//     })
//   })
// }

function setImg() {
  setEditorImg(
    '[{"url":"https://sitcontentjdcdn.aikan.pdnews.cn/zhbj-20231011/image/content/42a7f02dc9dd48978554bf58bb32003d.png"},{"url":"https://sitcontentjdcdn.aikan.pdnews.cn/zhbj-20231011/image/content/42a7f02dc9dd48978554bf58bb32003d.png"}]'
  )
}

function setVideo() {
  setEditorVideo(
    '[{"url":"https://sitcontentjdcdn.aikan.pdnews.cn/zhbj-20231026/vod/content/a9e46a5536e14d2583fbf76d11fa4d62.mp4","duration":60}]'
  )
}
function setVideo1() {
  setEditorVideo(
    '[{"url":"https://sitcontentjdcdn.aikan.pdnews.cn/zhbj-20231012/vod/content/a536750a9066459b96a4f6a4c6d71ed5.mp4"}]'
  )
}
